MYPY(1)

NAME
mypy - Optional Static Typing for Python

DESCRIPTION
usage: mypy [-h] [-v] [-V] [--python-version x.y] [--platform PLATFORM] [-2]

    [--ignore-missing-imports] [--follow-imports {normal,silent,skip,error}] [--disallow-any-unimported] [--disallow-any-expr] [--disallow-any-decorated] [--disallow-any-explicit] [--disallow-any-generics] [--disallow-untyped-calls] [--disallow-untyped-defs] [--disallow-incomplete-defs] [--check-untyped-defs] [--disallow-subclassing-any] [--warn-incomplete-stub] [--disallow-untyped-decorators] [--warn-redundant-casts] [--no-warn-no-return] [--warn-return-any] [--warn-unused-ignores] [--warn-unused-configs] [--show-error-context] [--no-implicit-optional] [-i] [--quick-and-dirty] [--cache-dir DIR] [--skip-version-check] [--strict-optional] [--strict-optional-whitelist [GLOB [GLOB ...]]] [--junit-xml JUNIT_XML] [--pdb] [--show-traceback] [--stats] [--inferstats] [--custom-typing MODULE] [--custom-typeshed-dir DIR] [--scripts-are-modules] [--config-file CONFIG_FILE] [--show-column-numbers] [--find-occurrences CLASS.MEMBER] [--strict] [--shadow-file SOURCE_FILE SHADOW_FILE] [--any-exprs-report DIR] [--cobertura-xml-report DIR] [--html-report DIR] [--linecount-report DIR] [--linecoverage-report DIR] [--memory-xml-report DIR] [--txt-report DIR] [--xml-report DIR] [--xslt-html-report DIR] [--xslt-txt-report DIR] [-m MODULE] [-c PROGRAM_TEXT] [-p PACKAGE] [files [files ...]]

  optional arguments:

-h, --help
    show this help message and exit

-v, --verbose
    more verbose messages

-V, --version
    show program's version number and exit

--python-version x.y
    use Python x.y

--platform PLATFORM
    typecheck special-cased code for the given OS platform (defaults to sys.platform).

-2, --py2
    use Python 2 mode

--ignore-missing-imports
    silently ignore imports of missing modules

--follow-imports {normal,silent,skip,error}
    how to treat imports (default normal)

--disallow-any-unimported
    disallow Any types resulting from unfollowed imports

--disallow-any-expr
    disallow all expressions that have type Any

--disallow-any-decorated
    disallow functions that have Any in their signature after decorator transformation

--disallow-any-explicit
    disallow explicit Any in type positions

--disallow-any-generics
    disallow usage of generic types that do not specify explicit type parameters

--disallow-untyped-calls
    disallow calling functions without type annotations from functions with type annotations (inverse: --allow-untyped-calls)

--disallow-untyped-defs
    disallow defining functions without type annotations or with incomplete type annotations (inverse: --allow-untyped-defs)

--disallow-incomplete-defs
    disallow defining functions with incomplete type annotations (inverse: --allow-incomplete-defs)

--check-untyped-defs
    type check the interior of functions without type annotations (inverse: --no-check-untyped-defs)

--disallow-subclassing-any
    disallow subclassing values of type 'Any' when defining classes (inverse: --allow-subclassingany)

--warn-incomplete-stub
    warn if missing type annotation in typeshed, only relevant with --check-untyped-defs enabled (inverse: --no-warn-incomplete-stub)

--disallow-untyped-decorators
    disallow decorating typed functions with untyped decorators (inverse: --allow-untyped-decorators)

--warn-redundant-casts
    warn about casting an expression to its inferred type (inverse: --no-warn-redundant-casts)

--no-warn-no-return
    do not warn about functions that end without returning (inverse: --warn-no-return)

--warn-return-any
    warn about returning values of type Any from nonAny typed functions (inverse: --no-warn-returnany)

--warn-unused-ignores
    warn about unneeded '# type: ignore' comments (inverse: --no-warn-unused-ignores)

--warn-unused-configs
    warn about unnused '[mypy-<pattern>]' config sections (inverse: --no-warn-unused-configs)

--show-error-context
    Precede errors with "note:" messages explaining context (inverse: --hide-error-context)

--no-implicit-optional
    don't assume arguments with default values of None are Optional (inverse: --implicit-optional)

-i, --incremental
    enable module cache, (inverse: --no-incremental)

--quick-and-dirty
    use cache even if dependencies out of date (implies --incremental)

--cache-dir DIR
    store module cache info in the given folder in incremental mode (defaults to '.mypy_cache')

--skip-version-check
    allow using cache written by older mypy version

--strict-optional
    enable experimental strict Optional checks (inverse: --no-strict-optional)

--strict-optional-whitelist [GLOB [GLOB ...]]
    suppress strict Optional errors in all but the provided files (experimental -- read documentation before using!). Implies --strict-optional. Has the undesirable side-effect of suppressing other errors in non-whitelisted files.

--junit-xml JUNIT_XML
    write junit.xml to the given file

--pdb
    invoke pdb on fatal error

--show-traceback, --tb
    show traceback on fatal error

--stats
    dump stats

--inferstats
    dump type inference stats

--custom-typing MODULE
    use a custom typing module

--custom-typeshed-dir DIR
    use the custom typeshed in DIR

--scripts-are-modules
    Script x becomes module x instead of __main__

--config-file CONFIG_FILE
    Configuration file, must have a [mypy] section (defaults to mypy.ini)

--show-column-numbers
    Show column numbers in error messages (inverse: --hide-column-numbers)

--find-occurrences CLASS.MEMBER
    print out all usages of a class member (experimental)

--strict
    Strict mode. Enables the following flags: --disallow-untyped-calls, --disallow-untyped-defs, --disallow-incomplete-defs, --check-untyped-defs, --disallow-subclassing-any, --disallow-untypeddecorators, --warn-redundant-casts, --warn-returnany, --warn-unused-ignores, --warn-unused-configs, --no-implicit-optional, --strict-optional

--shadow-file SOURCE_FILE SHADOW_FILE
    Typecheck SHADOW_FILE in place of SOURCE_FILE.

  report generation:

    Generate a report in the specified format.

--any-exprs-report DIR

--cobertura-xml-report DIR

--html-report DIR

--linecount-report DIR

--linecoverage-report DIR

--memory-xml-report DIR

--txt-report DIR

--xml-report DIR

--xslt-html-report DIR

--xslt-txt-report DIR

  How to specify the code to type check:

-m MODULE, --module MODULE
    type-check module; can repeat for more modules

-c PROGRAM_TEXT, --command PROGRAM_TEXT
    type-check program passed in as string

-p PACKAGE, --package PACKAGE
    type-check all files in a directory

files
    type-check given files or directories

environment variables: MYPYPATH additional module search path